// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// EventHandlerFunc turns a function with the right signature into a event handler
type EventHandlerFunc func(EventParams, *ticketboss) middleware.Responder

// Handle executing the request and returning a response
func (fn EventHandlerFunc) Handle(params EventParams, principal *ticketboss) middleware.Responder {
	return fn(params, principal)
}

// EventHandler interface for that can handle valid event params
type EventHandler interface {
	Handle(EventParams, *ticketboss) middleware.Responder
}

// NewEvent creates a new http.Handler for the event operation
func NewEvent(ctx *middleware.Context, handler EventHandler) *Event {
	return &Event{Context: ctx, Handler: handler}
}

/*Event swagger:route POST /events ticketboss events event

Create a new Event.

JSON Response is provided with respective success or fail details.

*/
type Event struct {
	Context *middleware.Context
	Handler EventHandler
}

func (o *Event) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewEventParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *ticketboss
	if uprinc != nil {
		principal = uprinc.(*ticketboss) // this is really a ticketboss, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
